Overview of the Web Deployment Tool for IIS Manager

The Web Deployment Tool (Web Deploy) synchronizes IIS configuration, content, SSL certificates, and other types of data from a user-specified site or server to a user-specified destination. You can also deploy objects, such as registry keys, that are not included by default.

Management Service Delegation

In IIS Manager, Web Deploy adds an administrators-only feature at the server level called Management Service Delegation that lets you control, with a high degree of precision, the deployment actions that remote users can take. For more information, see Management Service Delegation Page.

Export and Import Applications

From the IIS Manager Actions pane, you can use the tool's Export Application Package Wizard to create compressed files (packages) that contain your sites, applications, and content. For more information, see Export Application Package and Export Server Package Wizard Pages.

After you export a package, you can use the Import Application Package Wizard to install the package's contents at a different location. For more information, see Import Application Package and Import Server or Site Package Wizard Pages.

Command-line features

The Web Deployment Tool's Msdeploy.exe executable program offers many powerful command-line features. For summary help about Msdeploy.exe features, type msdeploy -help in a Command Prompt window. For more detailed help online, see Web Deployment Tool.

Additional Online Resources

IIS.NET: Web Deployment Tool

IIS.NET: Web Deployment Tool Forum

IIS.NET: Microsoft Web Deployment Team Blog Posts


Web Deployment Tool User Interface (UI) Help

IIS Manager provides descriptions of all user interface (UI) elements on each feature page, dialog box, and wizard page within IIS Manager. To display this help, press F1 on the active feature page, dialog box, or wizard page.

In This Section

Management Service Delegation Page

Export Application Package and Export Server Package Wizard Pages

Import Application Package and Import Server or Site Package Wizard Pages


Management Service Delegation Page

Use the Management Service Delegation page to specify rules that control remote user deployment rights. The Management Service Delegation page can be used only by administrators and appears only at the server level.

UI Elements

Element Name | Description
Provider | Displays the provider or providers to which the rule applies.
Path | Displays the path to which the rule applies.
Path Type | Displays the type of the path. Possible values are PathPrefix, StringPrefix, StringSuffix, ConnectionString, and RegularExpression.
Actions | Displays the actions that the rule will take. For Web Deploy providers, typical values are Read, Write, and *.
Identity Type | Displays the type of identity under which the rule will run. Possible values are CurrentUser, ProcessIdentity, and SpecificUser.
User Name | Displays the user name when SpecificUser has been selected as the identity type. When the identity type is CurrentUser or ProcessIdentity, no user name will be displayed.
State | Displays whether the rule is enabled or disabled. You can enable or disable a rule by clicking Enable Rule or Disable Rule in the Actions pane.

Actions Pane Elements

Element Name | Description
Add Rule… | Opens the Add Rule dialog box. Select this option to add a rule. For more information, see Add Rule Dialog Box (Management Service Delegation).
Add User To Rule… | Opens the Add User To Rule dialog box. For more information, see Add User to Rule Dialog Box.
Edit… | Opens the Edit Rule dialog box. For more information, see Add or Edit Rule Dialog Boxes.
Remove | Removes the selected delegation rule or delegation rule user.
Disable Rule | Disables the selected delegation rule.
Enable Rule | Enables the selected delegation rule.
Edit Feature Settings… | Opens the Edit Feature Settings dialog box. For more information, see Edit Feature Settings Dialog Box (Management Service Delegation).


Add Rule Dialog Box (Management Service Delegation)
See Also

Use the Select Rule Template dialog box to select a template that you can use to create a custom delegation rule. You can choose a blank template or an installed template designed for specific scenarios.

UI Elements

Installed Templates

Element Name Description

Blank Rule

Creates a blank rule that you can customize.

Deploy Content Only

Creates a rule that enables content deployment. The rule will enable any Web Management Service (WMSvc) authorized user to publish content to a path to which that user already has WMSvc authorization. The rule can be edited to restrict access to a specific path or user. This rule uses the contentPath provider, which synchronizes Web site content. For more information, see Web Deploy contentPath Provider.

Deploy Applications with Content

Creates a rule that enables application deployments. This template does not include a rule to mark a folder as an application, but it is often used in combination with such a rule. The rule will enable any WMSvc authorized user to publish an application to a path to which that user already has WMSvc authorization. The rule can be edited to restrict access to a specific path or user. This rule uses the contentPath and iisApp providers. For more information, see Web Deploy contentPath Provider and Web Deploy iisApp Provider.

Deploy Databases

Creates a rule that enables database deployment. The rule will enable any WMSvc authorized user to publish to any database to which they have access. The template specifies that the account being used is CurrentUser, which means that the connection string will be used to authenticate the user on the database server. The rule can be edited to restrict access to a specific database server or name. This rule uses the dbFullSql provider, which enables first-time publishing of databases from a local SQL Server development database to a remotely hosted SQL Server database. For more information, see Web Deploy dbFullSql Provider.

Mark Folders as Applications

Creates a rule that marks a folder as an application. The rule will enable any WMSvc authorized user to mark a folder as an application. If the user is not an administrator, you will have to change the identity type to an account that has write access to the ApplicationHost.config file. The default identity type for this rule is SpecificUser. This rule uses the createApp provider, which is required to mark folders as applications, and whose functionality is included in the iisApp provider. For more information, see Web Deploy Providers.

Set Permissions for Applications

Creates a rule that sets ACLs for an application path. The rule will enable any WMSvc authorized user to set file system ACLs for an application path to which the user already has WMSvc authorization. The template specifies that the account that is being used is CurrentUser, which means that the user has to have permissions before the user can change the ACLs. The rule can be edited to restrict access to a specific path or user. This rule uses the setAcl provider, which sets permissions on a destination folder. For more information, see Web Deploy setAcl Provider .

Backup and Restore Databases (Using SQL Authentication)

Creates a rule that backs up and restores databases by using SQL authentication. The rule will enable any WMSvc authorized user to create or restore a backup of the database to which that user already has access. The backup and restore operations will be performed as a specific user identity using SQL authentication. The rule can be edited to restrict access to a specific database and a specific set of users.

Note
Use this template with the IIS Database Manager extension. For more information about IIS Database Manager, see Database Manager.

Backup and Restore Databases (Using Windows Integrated Security)

Creates a rule that backs up and restores databases by using Windows authentication. The rule will enable any WMSvc authorized user to create or restore a backup of the database to which that user already has access. The rule can be edited to restrict access to a specific database and a specific set of users.

Note
Use this template with the IIS Database Manager extension. For more information about IIS Database Manager, see Database Manager.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages

Other Resources

Web Deploy Providers


Add or Edit Rule Dialog Boxes

Use the Add Rule and Edit Rule dialog boxes to add and edit delegation rules.

UI Elements

Element Name | Description
Providers | Click the drop-down list to select or clear the providers that you want to add or remove from the rule, then click the drop-down arrow to accept the changes. The providers will be displayed in a comma-delimited list. For more information about Web Deploy providers, see Web Deploy Providers.
Actions | Click the drop-down list to select or clear the actions that you want to add or remove from the rule, then click the drop-down arrow to accept the changes. The actions will be displayed in a comma-delimited list. Typical values for Web Deploy are Read, Write, and *.
Path Type | Select a path type from the drop-down list. Possible values are PathPrefix, StringPrefix, StringSuffix, ConnectionString, and RegularExpression. For more information about regular expressions, see Regular Expressions.
Path | Type the path to which the rule will apply.
Identity Type | Select the identity type for the rule from the drop-down list. The selected identity will execute the rule. Possible values are CurrentUser, ProcessIdentity, and SpecificUser. CurrentUser specifies that the current user's identity will be used. ProcessIdentity specifies that the WMSvc local service identity will be used. SpecificUser specifies that a special identity that you designate will be used. If you select SpecificUser, you must supply the credentials by using the Specify Credentials Set button.
Specify Credentials | Enables the Set button when you select SpecificUser as the identity type.
Set | Opens the Set Credentials dialog box that lets you specify a user name and password for the SpecificUser identity. For more information, see Set Credentials Dialog Box (Web Deploy).


Set Credentials Dialog Box (Web Deploy)

Use the Set Credentials dialog box to provide the user name and password of a Windows user.

UI Elements

Element Name | Description
User name | Type the user name of a Windows user.
Password | Type the password.
Confirm password | Retype the password to confirm it.

See Also

Concepts

Add or Edit Rule Dialog Boxes
Edit Connection String Dialog Box


Add User to Rule Dialog Box

Use the Add User to Rule dialog box to allow or deny a user access to a rule.

UI Elements

Element Name | Description
Name | Type the user name.
Access Type | Select the type of access to give to the specified user. Possible values are Allow and Deny.
Is Role? | Select this check box if the user name that you specified is an alias for a group of users who will be allowed or denied access.


Edit Feature Settings Dialog Box (Management Service Delegation)

Use the Edit Feature Settings dialog box to allow administrators to bypass delegation rules and to enable the logging of failed requests.

UI Elements

Element Name Description

Allow administrators to bypass rules

Select this option to allow administrators to bypass the specified delegation rules.

Enable failed request tracing logs for the delegation service

Select this option to enable the logging of failed request information.

Warning
To use this feature, the failed request tracing module must be installed.


Export Application Package and Export Server Package Wizard Pages

Select the Contents of the Package Page (Export Package)

Select Parameters Page

Save Package Page

Encrypt Password Dialog Box

Export Progress and Summary Page


Select the Contents of the Package Page (Export Package)

Use the Select the Contents of the Package page of the Export Application Package Wizard to view the components that are included in the package that you want to create.

Packages can contain components such as the registry settings, COM, GAC assemblies, or certificates. To install these components on your server, you must be a member of the Administrators group, or you must have been delegated the appropriate authority. You do not need administrator user rights to install only content.

UI Elements

Element Name Description

Package contains

Lists the components that are included in your package. You can specify what you want to include in your package by selecting or clearing the appropriate component check boxes. For example, you can include or exclude a SQL database or GAC assembly by selecting or clearing the corresponding check box.

Caution
Some components may be required by the application. If you clear the check boxes for these components, the application may not function correctly after installation.

Attributes

Displays, in the right pane, the attributes of the selected file, directory, or component. These values are read-only.

Manage Components…

Opens the Manage Components dialog box. This lets you select the components that you want to include. For more information, see Manage Components Dialog Box.

Advanced Settings…

Opens the Advanced Settings dialog box. This lets you specify operation settings and rules. For more information, see Advanced Settings Dialog Box (Export).

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages

Other Resources

Export a Package through IIS Manager (online resource)


Manage Components Dialog Box

Use the Manage Components dialog box of the Export Application Package Wizard to add components, such as COM objects or GAC assemblies, to your package.

UI Elements

Column Headings

Element Name Description

Provider Name

Specifies the component that you want to package. Each component has a provider. Click the field to use the drop-down list to select a provider name. Hover over a provider name to view a description of that provider. For example, if you select dbFullSql, you will package the path of a script or a connection string. For more information about providers, see Web Deploy Providers.

Important
If you are packaging a Web site, the iisApp provider (selected by default) will mark the Web site as an application on the destination. If you want to package a Web site and all its related configuration (such as the application pool name, the location of the content directory, and any certificates), use the appHostConfig provider. If you use the iisApp provider, the Web site will become an application on the destination that inherits all its settings (such as application pool name and content directory) from the site into which it is installed.

Path

Specifies the path of the component that will provide the data for the package. For example, if you select dbFullSql, the path can specify a script like C:\SQLfiles\installSQL.sql, or a connection string like Data Source=.\sqlexpress;Integrated Security=SSPI;Initial Catalog=db1.

Provider Settings

Specifies the provider settings that you want to use for the selected provider. Click the field to use the browse (…) button to open the Provider Settings dialog box. For more information, see Provider Settings Dialog Box.

Buttons

Element Name | Description
Remove | Deletes the selected entry.
Move Up | Moves the selected row up in the list. Entries will be installed in the order that they appear in the list. The order of entries is important for some providers. For example, a script to create a table should be run before a script to populate a table.
Move Down | Moves the selected row down in the list. Entries will be installed in the order that they appear in the list.

See Also

Concepts

Select the Contents of the Package Page (Export Package)
Export Application Package and Export Server Package Wizard Pages


Provider Settings Dialog Box

Use the Provider Settings dialog box to specify settings for the selected provider. Not all providers have settings.

UI Elements

Element Name | Description
Setting name | Displays the name of the setting for the selected provider. Only settings relevant to the selected provider are listed.
Setting value | Type or select the value for the setting. If a drop-down list is available, the values that are possible for the setting will be in the list. For values that you must type, the description box provides information about which values are acceptable.
Setting description | Displays a description of the selected setting for the provider. Provides information about which values are allowed for the setting.

See Also

Concepts

Manage Components Dialog Box
Select the Contents of the Package Page (Export Package)
Export Application Package and Export Server Package Wizard Pages

Other Resources

Web Deploy Provider Settings


Advanced Settings Dialog Box (Export)

Use the Advanced Settings dialog box of the Export Application Package Wizard to specify settings for your package.

UI Elements

Advanced Options

Element Name Description

Encrypt Password

Click the … to open the Encrypt Password dialog box to specify an alphanumeric password that controls access to secure properties in IIS configuration.

Web Deploy automatically detects whether an encrypted object, such as an application pool with a custom identity, is present in server-level configuration files (for example, ApplicationHost.config or Machine.config). If an encrypted object is present, you must provide a password for the object. If you do not specify the correct password, the export operation will fail.

Important
Web Deploy does not check Web.config files for encrypted objects.

Include ACls

Select True if ACLs of the path that you specify will be copied from the source to the destination; otherwise, select False. This setting applies to the file system, registry, and metabase, and only to these providers: appHostConfig, contentPath, iisApp, metaKey, webServer, and webServer60. The default is false.

Link Extension

Click the field on the right and then click the arrow to show the drop-down list of link extensions. Select or clear the extensions in the list to enable or disable the link extensions that you want to apply to the operation. Link extensions include or exclude specific kinds of data in an operation. Available Web Deploy extensions are AppPoolExtension, CertificateExtension, ContentExtension, FrameworkConfigExtension, and HttpCertConfigExtension. These extensions are selected by default. For more information about link extensions, see Web Deploy Link Extensions.

Retry Attempts

Type the number of times the provider will retry after a failure. The default number of retries is 5. By default, there is a delay of one second between each retry. The retry attempts setting can only be used with the contentPath provider.

Retry Interval

Type a value in milliseconds. The value will specify the time interval between provider retry attempts. The default is 1000 (one second). This setting can only be used with the contentPath provider.

Trace Level

Select a value from the drop-down list that specifies the level of detail in error message logs. Possible values are Off, Error, Warning, Info, and Verbose. The default is Info. Off means that no error messages will be logged. Verbose means that all messages will be logged.

Synchronization Options

Element Name Description

Rules

Opens the Enable or Disable Rules dialog box that lets you specify rules for the operation. For more information, see Enable or Disable Rules Dialog Box.

WhatIf

Click the drop-down list to select True or False. True specifies that the operation will be run without actually making any changes. You can use this setting to see the results of an operation if all parts of the operation succeed. The default value is False.

Note
A command that appears to have run successfully with the WhatIf setting may fail when the command is run without using the WhatIf setting. This can happen if unexpected errors occur during the operation. For example, because no data is written during a WhatIf operation, write permission errors will not be detected. The WhatIf setting shows only what will happen if all operations in the command succeed.

See Also

Concepts

Select the Contents of the Package Page (Export Package)
Export Application Package and Export Server Package Wizard Pages


Enable or Disable Rules Dialog Box

Use the Enable or Disable Rules dialog box to enable or disable rules that affect the outcome of a synchronization operation. Select State from the Group By drop-down list to group rules into disabled and enabled categories, or No Grouping to view the rules in alphabetical order.

UI Elements

Column Headings

Element Name | Description
Name | Lists the names of the synchronization rules that you can enable or disable. The rules that are in bold are enabled by default; the rules that are in shaded text are disabled by default. You can enable or disable a rule by selecting the rule and by using the Enable Rule or Disable Rule buttons. For more information about these rules, see Web Deploy Rules.

Buttons

Element Name | Description
Enable Rule | Enables the selected rule.
Disable Rule | Disables the selected rule.

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages
Import Application Package and Import Server or Site Package Wizard Pages


Select Parameters Page

Use the Select Parameters page of the Export Application Package Wizard to add or remove parameters to your package. You can assign a parameter to an attribute when you create the package. Later, when the package is installed, the user can specify a custom value for the parameter, and the new value will be assigned to the attribute. Parameters are automatically generated for each provider.

UI Elements

Column Headings

Element Name | Description
Name | Lists the names of the parameters that you have added by using the Add Parameter dialog box. You can edit a parameter by double-clicking the parameter or by selecting the parameter and then clicking Edit.
Type | Displays the parameter type for the attribute that will be parameterized.
Scope | Displays the scope for the attribute that will be parameterized.
Match | Displays the matching expression that will identify the attribute to be parameterized.

Buttons

Element Name Description

Add Parameter

Opens the Add Parameter dialog box. This lets you add a parameter and set its properties. For more information, see Add or Edit Parameter Dialog Box.

Add Parameter Entry

Opens the Add Parameter Entry dialog box. This lets you configure the Type, Scope, and Match values for the selected parameter. For more information, see Add Parameter Entry Dialog Box. This option is enabled when you select a parameter or a parameter entry.

Edit

If a parameter is selected, this button opens the Edit Parameter dialog box. This lets you edit an existing parameter’s properties. For more information, see Add or Edit Parameter Dialog Box.

If a parameter entry is selected, this button opens the Edit Parameter Entry dialog box. For more information, see Edit Parameter Entry Dialog Box.

Remove

Removes the selected parameter.

Move Up

Moves the selected parameter up in the list of parameters. Parameters are processed in the order that they appear in the list.

Move Down

Moves the selected parameter down in the list of parameters. Parameters are processed in the order that they appear in the list.

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages


Add or Edit Parameter Dialog Box

Use the Add Parameter dialog box or Edit Parameter dialog box to add a new parameter for your application package or edit an existing parameter.

UI Elements

Element Name Description

Name

Type a name for your parameter. For example, Connection String.

Default Value

Type a default value for the parameter. When the package is later deployed, the parameter will have this value unless the user specifies a different value. For example, if you typed Connection String for the parameter name, you can use Data Source=.\SQLExpress;Database=Test;Integrated Security for the default value. This entry is not required.

Important
If you want to require the user to provide a value for the parameter, do not specify a default value.

Tags

Type a comma-delimited list of custom attributes. Tags are optional attributes for the parameter that can be referenced later. For example, your parameter might be tagged as a password so that a user interface will not display the password value. This entry is not required. By using the example in the Default Value element description, you can use the tags SQL, SQLConnectionString for the Connection String parameter.

Description

Enter a description for your parameter. For example, "This is the connection string for the database that your application uses. Please change it if your environment has a different SQL server or database." The description will be put into the Parameters.xml file inside the package and can be displayed at a command prompt by typing msdeploy -verb:getParameters -source:package=<PackageFileName>.

Type

Optionally select a parameter validation type. Possible values are None, Regular Expression, Enumeration, or Boolean. The default value is None. If you select a parameter validation type other than None, the value that the user provides for the parameter will be checked to see if it meets the conditions that you specified. If you select Regular Expression or Enumeration, you must provide a validation string in the Validation String box.

Validation String

Type a regular expression or a comma-delimited list of enumeration values. For more information about Regular Expressions, see Regular Expressions.

See Also

Concepts

Select Parameters Page
Export Application Package and Export Server Package Wizard Pages


Add Parameter Entry Dialog Box

Use the Add Parameter Entry dialog box to specify the Type, Scope, and Match values for your parameter.

UI Elements

Element Name | Description
Type | Use the drop-down list to select the parameter type that you want to use for the attribute that will be parameterized. Possible parameter types are Xml File, Text File, Text File Position, Provider Path, Deployment Attribute, Destination Binding, and Destination Virtual Directory. For example, if you created a Connection String parameter, you might select Xml File in the drop-down list because the connection string will be located inside a Web.config file, which is in XML format.
Scope | Enter a scope for the attribute that will be parameterized. This value is a required regular expression. For example, if Xml File is the parameter type, you might use the regular expression \\web.config$ for the scope. The first backslash escapes the second backslash, and the dollar sign ($) stops the match string at the end of the line. Thus, "\web.config" will be the resulting scope. For more information about regular expressions, see Regular Expressions.
Match | Type an expression that will identify the attribute to be parameterized. This value depends on the type. In some cases it will be a regular expression or an XPath expression. The Xml File type requires that the matching value be an XPath expression. Following the previous example, you could use the XPath expression //connectionStrings/add/@connectionString to match the connection string entry inside a Web.config file.

See Also

Concepts

Select Parameters Page
Export Application Package and Export Server Package Wizard Pages


Edit Parameter Entry Dialog Box

Use the Edit Parameter Entry dialog box to edit the Type, Scope, and Match values for your parameter. If you have not yet created a parameter, see Add or Edit Parameter Dialog Box.

UI Elements

Element Name | Description
Type | Use the drop-down list to change the parameter type. Possible parameter types are Xml File, Text File, Text File Position, Provider Path, Deployment Attribute, Destination Binding, and Destination Virtual Directory. For example, if you created a Connection String parameter, you might select Xml File in the drop-down list because the connection string will be located inside a Web.config file, which is in XML format.
Scope | Edit a scope for the attribute that will be parameterized. This value is a required regular expression. For example, if Xml File is the parameter type, you might use the regular expression \\web.config$ for the scope. The first backslash escapes the second backslash, and the dollar sign ($) stops the match string at the end of the line. Thus, "\web.config" will be the resulting scope. For more information about regular expressions, see Regular Expressions.
Match | Edit the expression that will identify the attribute to be parameterized. This value depends on the type. In some cases it will be a regular expression or an XPath expression. The Xml File type requires that the matching value be an XPath expression. Following the previous example, you could use the XPath expression //connectionStrings/add/@connectionString to match the connection string entry inside a Web.config file.

See Also

Concepts

Select Parameters Page
Export Application Package and Export Server Package Wizard Pages


Save Package Page

Use the Save Package page of the Export Application Package Wizard to specify a file name and a location to use when you save your package.

UI Elements

Element Name | Description
Package path | Type a file name for your package. The file name must have a .zip file name extension.
Browse… | Click the browse button to specify the location where you want to save your package.

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages


Encrypt Password Dialog Box

Use the Encrypt Password dialog of the Export Application Package Wizard to provide a password for package content that has settings that have been marked as secure.

UI Elements

Element Name | Description
Password | Type the password that will be required when the package is later imported. If you do not provide a password for settings that are marked as secure, you will not be able to export the package.
Confirm password | Retype the password to confirm it.

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages


Export Progress and Summary Page

Use the Export Progress and Summary page of the Export Application Wizard to monitor the status of the export process, and view summary and detailed information of the operation after the wizard finishes.

UI Elements

Element Name Description

Status

The Status area displays the current operation that is being performed (for example, a file copy or database script operation). During the export process, you may be prompted for a password if the application contains items such as passwords or certificates that require encryption. Be aware that the export operation can take a long time if the amount of data is large, or if you are exporting data to a remote server.

Summary

Provides an overview of the actions that were performed, including any errors that occurred during the creation process.

Important
The Summary tab does not contain an exhaustive listing of the actions that were taken or errors that occurred. You can find information that is more detailed by clicking the Details tab.

Details

Provides a detailed listing of the actions that were performed. If any errors occurred, clicking this tab shows detailed error information that you can use for troubleshooting.

See Also

Concepts

Export Application Package and Export Server Package Wizard Pages


Import Application Package and Import Server or Site Package Wizard Pages

Select the Package Page

Decrypt Password Dialog Box

Select the Contents of the Package Page

Advanced Settings Dialog Box (Import)

Select Database Page

Enter Application Package Information Page

Overwrite Existing Files Page

Installation Progress and Summary Page


Select the Package Page

Use the Select the Package page to select an existing package that you want to install on your site or server.

UI Elements

Element Name | Description
Package path | Specifies the location of the package that you want to install on your site or server.
Browse… | Click the browse button to specify the location of the package that you want to import.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages


Decrypt Password Dialog Box

Use the Decrypt Password dialog box of the Import Application Package Wizard to provide a password for package content that has settings that have been marked as secure.

UI Elements

Element Name | Description
Password | Type the password that is required to decrypt the package contents. A password is required because some settings were marked as secure when the package was created. If you do not provide the password that was specified when the package was created, you will not be able to import the package.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages


Select the Contents of the Package Page

Use the Select the Contents of the Package page of the Import Application Package Wizard to view the components that are included in the package that you selected on the Select Package page.

Packages can contain components such as the registry settings, COM, GAC assemblies, or certificates. To install these components on your server, you must be a member of the Administrators group, or you must have been delegated the appropriate authority. You do not need administrator user rights to install only content.

UI Elements

Element Name Description

Package contains

Lists the components that are included in the package. You can specify what you want to deploy from the package by selecting or clearing the appropriate component check boxes. For example, you can include or exclude a SQL database or GAC assembly by selecting or clearing the corresponding check box.

Caution
Some components may be required by the application. If you clear the check boxes for these components, the application may not function properly after installation.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages


Advanced Settings Dialog Box (Import)

Use the Advanced Settings dialog box of the Import Application Package Wizard to specify settings for your package.

UI Elements

Advanced Options

Element Name Description

Decrypt Password

Opens the Decrypt Password dialog box that lets you type the password that is required to decrypt the package contents.

During an import operation, Web Deploy automatically detects whether an encrypted object, such as an application pool with a custom identity, is present in the package's server-level configuration files (for example, ApplicationHost.config or Machine.config). If an encrypted object is present, you must provide a password for the object. If you do not specify the correct password, the import operation will fail.

Include ACls

Select True if ACLs of the path that you specify will be copied from the source to the destination; otherwise, select False. This setting applies to the file system, registry, and metabase, and only to these providers: appHostConfig, contentPath, iisApp, metaKey, webServer, and webServer60. The default is False.

Link Extension

Click the field on the right and then click the arrow to show the drop-down list of link extensions. Select or clear the extensions in the list to enable or disable the link extensions that you want to apply to the operation. Link extensions include or exclude specific kinds of data in an operation. Available Web Deploy extensions are AppPoolExtension, CertificateExtension, ContentExtension, FrameworkConfigExtension, and HttpCertConfigExtension. These extensions are selected by default. For more information about link extensions, see Web Deploy Link Extensions.

Retry Attempts

Type the number of times the provider will retry after a failure. The default number of retries is 5. By default, there is a delay of one second between each retry. The retry attempts setting can only be used with the contentPath provider.

Retry Interval

Type a value in milliseconds. The value will specify the time interval between provider retry attempts. The default is 1000 (one second). This setting can only be used with the contentPath provider.

Trace Level

Select a value from the drop-down list that specifies the level of detail in error message logs. Possible values are Off, Error, Warning, Info, and Verbose. The default is Info. Off means that no error messages will be logged. Verbose means that all messages will be logged.

Synchronization Options

Element Name Description

Rules

Opens the Enable or Disable Rules dialog box that lets you specify rules for the operation. For more information, see Enable or Disable Rules Dialog Box.

WhatIf

Click the drop-down list to select True or False. True specifies that the operation will be run without actually making any changes. You can use this setting to see the results of an operation if all parts of the operation succeed. The default value is False.

Note
A command that appears to have run successfully with the WhatIf setting may fail when the command is run without using the WhatIf setting. This can happen if unexpected errors occur during the operation. For example, because no data is written during a WhatIf operation, write permission errors will not be detected. The WhatIf setting shows only what will happen if all operations in the command succeed.

See Also

Concepts

Select the Contents of the Package Page
Import Application Package and Import Server or Site Package Wizard Pages


Select Database Page

Use the Select Database page to select the database options that you want to use for the package that you are installing. This page only appears if more than one database type is available in the package.

Note
This page will also not appear if there is more than one database type available in the package, but you have cleared the check boxes on the Select the Contents of the Package page for all but one database type.

UI Elements

Element Name | Description
Choose the database that you would like to use | Select the type of database for your installation. Possible database types are SQL, MySQL, VistaDB, SQLite, Flat File, or No Database. The contents of the package that you are installing determine which database options appear. Only the SQL and MySQL options have associated providers. For more information, see Web Deploy dbFullSql Provider and Web Deploy MySQL Provider.
Create new or use existing database | Select Create new database to create a new database or Use existing database to use an existing database. This option is enabled only when SQL or MySQL has been chosen as the database type.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages
Enter Application Package Information Page


Enter Application Package Information Page

Use the Enter Application Package Information page of the Import Application Package Wizard to specify values for the parameters that have been declared in the package. Each parameter will have a field on the page. The fields that appear on the page will depend on the parameters that have been declared in the package.

UI Elements

Element Name | Description
<Parameter Name> | Specify a value for the parameter that is required to install your package. This information can include the full site path to where you want to install your application, user credentials, or the name of the database for your application. For example, you can change the application path value to specify where the application should install, such as Default Web Site/NewApp.

See Also

Concepts

Edit Connection String Dialog Box


Edit Connection String Dialog Box

Use the Edit Connection String dialog box to specify the connection string for the database server that you want to use. The options available in the dialog box depend on the type of database that you will use (for example, SQL Server or MySQL).

UI Elements

Element Name | Description
SQL Server | Select this option to let Web Deploy create a SQL connection string based on the information that you provide in the Server, Database, and Credentials boxes. If you want to edit the connection string yourself, select the Custom option and type the connection string in the box below the Custom option.
MySQL | Select this option to let Web Deploy create a MySQL connection string based on the information that you provide in the Server, Database, and Credentials boxes. If you want to edit the connection string yourself, select the Custom option and type the connection string in the box below the Custom option.
Server | Type the path of the database server that you want to use.
Database | Type the name of the database that you want to use.
Use Windows Integrated Security | Select this option to use Windows Integrated Security. Windows Integrated Security passes user credentials to ASP.NET without requiring re-authentication if the user is already logged on to Windows. This authentication method works best if both the client and server are within the same domain.
Specify credentials | Select this option and click Set to open the Set Credentials dialog box to specify a Windows user name and password. For more information, see Set Credentials Dialog Box (Web Deploy).
Custom | Select this option to manually type a connection string to the database server that you want to use (for example, Server=.\SQLExpress;Database=Test;Integrated Security=true).

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages
Enter Application Package Information Page


Overwrite Existing Files Page

Use the Overwrite Existing Files page to decide whether you want to append new files to the destination or overwrite existing files and delete those files that do not have counterparts in the application package.

UI Elements

Element Name | Description
No, just append the files in the application package to the destination. | Select this option to keep the existing files on the destination and add the new files from the application package.
Yes, delete all extra files and folders on the destination that are not in the application package. | Select this option to delete any files on the destination that are not included in the application package.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages


Installation Progress and Summary Page

Use the Installation Progress and Summary page to monitor the status of the import process, and view summary and detailed information of the operation after the wizard finishes.

UI Elements

Element Name Description

Status

The Status area displays the current operation that is being performed (for example, a file copy or database script operation). During the import process, you may be prompted for a password if the application contains items such as passwords or certificates that require decryption. Be aware that the import operation can take a long time if the amount of data is large, or if you are importing data to or from a remote server.

Summary

Provides an overview of the actions that were performed, including any errors that occurred during the installation process.

Important
The Summary tab does not contain an exhaustive listing of the actions that were taken or errors that occurred. You can find information that is more detailed by clicking the Details tab.

Details

Provides a detailed listing of the actions that were performed. If any errors occurred, clicking this tab shows detailed error information that you can use for troubleshooting.

See Also

Concepts

Import Application Package and Import Server or Site Package Wizard Pages